// perfMeasure.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"


#include <GL/gl.h>
//#include <GL/glut.h>
//#include <GL/freeglut.h>

#include "GeoMeshLoader.h"
#include "GeoLodTreeLibrary.h"
#include "VertexData.h"

Geometry::GeoMeshLoader meshloader;
Geometry::Mesh *themesh;
Geometry::LodTreeLibrary* tree; 

#define USE_GRAPHICS

#ifndef USE_GRAPHICS
class myIndexData: public Geometry::IndexData {
public:
	Geometry::Mesh *m;

	float **vertices;
	unsigned int **indices;
	unsigned int *currentsizes;
	
	int rot;
	int offset;
	
	int* size;
	int* normalof;
	int* texcoorof;
	
public:
	
	unsigned int *getIndex (int i)
	{
		return indices[i];
	}
	
	float *getVertices (int i)
	{
		return vertices[i];
	}
	
	myIndexData (Geometry::Mesh *mesh): Geometry::IndexData(), m(mesh)
	{
		rot=0;
		
		size=new int[mesh->mSubMeshCount];
		normalof=new int[mesh->mSubMeshCount];
		texcoorof=new int[mesh->mSubMeshCount];

		indices=new unsigned int*[mesh->mSubMeshCount];
		vertices=new float*[mesh->mSubMeshCount];
		
		currentsizes=new unsigned int[mesh->mSubMeshCount];
		
		for (int i=0;i<mesh->mSubMeshCount;i++) {
			indices[i]=new unsigned int[mesh->mSubMesh[i].mIndexCount];
			
			/*} rgh: do a vertexbuffer for each submesh*/
			Geometry::VertexBuffer *v=mesh->mSubMesh[i].mVertexBuffer;
			size[i]=0;
			normalof[i]=0;
			texcoorof[i]=0;
			if (v->mVertexInfo && Geometry::VERTEX_POSITION) {size[i] +=3; normalof[i]+=3; texcoorof[i]+=3;}
			if (v->mVertexInfo && Geometry::VERTEX_NORMAL) {size[i] +=3; texcoorof[i]+=3;}
			if (v->mVertexInfo && Geometry::VERTEX_TEXCOORDS) size[i] +=2;
			vertices[i]=new float[v->mVertexCount*size[i]];
			
			for (int k=0;k<v->mVertexCount;k++) {
				if (v->mVertexInfo && Geometry::VERTEX_POSITION)
					for (int j=0;j<3;j++) {
						vertices[i][k*size[i]+j]=v->mPosition[k][j];
					}
				if (v->mVertexInfo && Geometry::VERTEX_NORMAL) 
					for (int j=0;j<3;j++) {
						vertices[i][k*size[i]+normalof[i]+j]=v->mNormal[k][j];
					}
				if (v->mVertexInfo && Geometry::VERTEX_TEXCOORDS)
					for (int j=0;j<2;j++) {
						vertices[i][k*size[i]+texcoorof[i]+j]=v->mTexCoords[k][j];
					}
			}
			
			}
		
		
	}
	~myIndexData (){}
	int currentmesh;
	void Begin (unsigned int submeshid, unsigned int indexcount)
	{
		//printf ("Begin: %d, %d\n", submeshid, indexcount);
		currentmesh=submeshid;
		currentsizes[submeshid]=indexcount;
	}
	void SetIndex (unsigned int i, unsigned int index) {
		//printf ("SetIndex: %d, %d\n", submeshid, index);
		indices[currentmesh][i]=index;
	}
	void End()
	{
		//printf ("End\n");
	}
	void BorrowIndexData(const Geometry::IndexData* indexdata) {printf ("Error, BorrowIndexData called unexpectedly\n"); exit (-4);}
	
	void Render(float s) {
	
		float d=m->mMeshBounds.maxY-m->mMeshBounds.minY;
		
		int current=0;
		int i;
		
		for (i=0;i<m->mSubMeshCount;i++) {
			if (tree->GetLeavesSubMesh()==i) continue;
			//handle triangle strips
				}
		i=tree->GetLeavesSubMesh();
		
		/*rgh: uno a uno, como hace GeoTool
		 glBegin(GL_TRIANGLES	);
		 for (int j=0;j<currentsizes[i];j++) {
		 int k=indices[i][j];
		 glNormal3fv(vertices[i]+8*k+3);
		 glTexCoord2fv(vertices[i]+8*k+6);
		 glVertex3fv(vertices[i]+8*k);
		 }
		 glEnd();*/
	
		
	}
	
};

#else 
class myIndexData: public Geometry::IndexData {
private:
	Geometry::Mesh *m;
	GLuint *m_IndexBuffer;
	GLuint *m_VertexBuffer;
	float **vertices;
	unsigned int **indices;
	unsigned int *currentsizes;

	GLuint texturas[2];
	int rot;
	int offset;

	int* size;
	int* normalof;
	int* texcoorof;

public:

	myIndexData (Geometry::Mesh *mesh): Geometry::IndexData(), m(mesh)
	{
		rot=0;

		size=new int[mesh->mSubMeshCount];
		normalof=new int[mesh->mSubMeshCount];
		texcoorof=new int[mesh->mSubMeshCount];
		//http://www.opengl.org/wiki/VBO_-_just_examples
		m_IndexBuffer=new GLuint[mesh->mSubMeshCount];
		m_VertexBuffer=new GLuint[mesh->mSubMeshCount];
		glGenBuffers (mesh->mSubMeshCount, m_IndexBuffer);
		glGenBuffers (mesh->mSubMeshCount, m_VertexBuffer);
		indices=new unsigned int*[mesh->mSubMeshCount];
		vertices=new float*[mesh->mSubMeshCount];
		currentsizes=new unsigned int[mesh->mSubMeshCount];


		for (int i=0;i<mesh->mSubMeshCount;i++) {
			indices[i]=new unsigned int[mesh->mSubMesh[i].mIndexCount];
			//rgh: modified later in SetIndex calls
			//	for (int j=0;j<mesh->mSubMesh[i].mIndexCount;j++)
			//		indices[i][j]=mesh->mSubMesh[i].mIndex[j];

			glBindBuffer (GL_ELEMENT_ARRAY_BUFFER, m_IndexBuffer[i]);
			glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof(int)*mesh->mSubMesh[i].mIndexCount, indices[i], GL_DYNAMIC_DRAW);


			/*} rgh: do a vertexbuffer for each submesh*/
			Geometry::VertexBuffer *v=mesh->mSubMesh[i].mVertexBuffer;
			size[i]=0;
			normalof[i]=0;
			texcoorof[i]=0;
			if (v->mVertexInfo && Geometry::VERTEX_POSITION) {size[i] +=3; normalof[i]+=3; texcoorof[i]+=3;}
			if (v->mVertexInfo && Geometry::VERTEX_NORMAL) {size[i] +=3; texcoorof[i]+=3;}
			if (v->mVertexInfo && Geometry::VERTEX_TEXCOORDS) size[i] +=2;
			vertices[i]=new float[v->mVertexCount*size[i]];

			for (int k=0;k<v->mVertexCount;k++) {
				if (v->mVertexInfo && Geometry::VERTEX_POSITION)
					for (int j=0;j<3;j++) {
						vertices[i][k*size[i]+j]=v->mPosition[k][j];
					}
					if (v->mVertexInfo && Geometry::VERTEX_NORMAL) 
						for (int j=0;j<3;j++) {
							vertices[i][k*size[i]+normalof[i]+j]=v->mNormal[k][j];
						}
						if (v->mVertexInfo && Geometry::VERTEX_TEXCOORDS)
							for (int j=0;j<2;j++) {
								vertices[i][k*size[i]+texcoorof[i]+j]=v->mTexCoords[k][j];
							}
			}


			glBindBuffer (GL_ARRAY_BUFFER, m_VertexBuffer[i]);
			glBufferData(GL_ARRAY_BUFFER, sizeof(float)*size[i]*v->mVertexCount, vertices[i], GL_STATIC_DRAW);

			glEnableClientState(GL_VERTEX_ARRAY);
			glVertexPointer(3, GL_FLOAT, sizeof(float)*size[i], (char*)0);   //The starting point of the VBO, for the vertices
			glEnableClientState(GL_NORMAL_ARRAY);
			glNormalPointer(GL_FLOAT, sizeof(float)*size[i], (char*)0+sizeof(float)*normalof[i]);   //The starting point of normals,
			glClientActiveTexture(GL_TEXTURE0);
			glEnableClientState(GL_TEXTURE_COORD_ARRAY);
			glTexCoordPointer(2, GL_FLOAT, sizeof(float)*size[i], (char*)0+sizeof(float)*texcoorof[i]);   //The starting point of texcoords,
		}
		//load textures
/*
		IplImage* texts[2] = {0,0}; 
		texts[0]=cvLoadImage("ml06lef.png");//leaf
		texts[1]=cvLoadImage("ML15brk.tif");//trunc

		int w=texts[0]->width, h=texts[0]->height;

		unsigned char* hoja=new unsigned char[w*h*4];
		for (int i=0; i<h;i++)
			for (int j=0;j<w;j++) {
				unsigned int t=0;
				for (int k=0;k<3;k++) {
					t+=hoja[i*w*4 + j*4 + k]=texts[0]->imageData[i*w*3 + j*3 +k];
				}
				hoja[i*w*4 + j*4 +3]= t==0?0:0xff;
			}

			if (!texts[0]||!texts[1])
			{
				printf ("Error loading tree textures\n");
				exit (-1);
			}


			assert (texts[0]->nChannels==3 && texts[1]->nChannels==3 &&
				!strcmp(texts[0]->channelSeq, "BGR") &&
				!strcmp(texts[1]->channelSeq, "BGR") );

			glGenTextures( 2, texturas );
			for (int i=0;i<2;i++) {
				//http://www.nullterminator.net/gltexture.html
				glBindTexture( GL_TEXTURE_2D, texturas[i]);
				glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );
				glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
					GL_LINEAR_MIPMAP_NEAREST );
				glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
				glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT );
				glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT );
				if (i==1) gluBuild2DMipmaps( GL_TEXTURE_2D, GL_RGB, texts[i]->width, texts[i]->height,
					GL_BGR, GL_UNSIGNED_BYTE, texts[i]->imageData	 );
				else
					gluBuild2DMipmaps( GL_TEXTURE_2D, GL_RGBA, texts[i]->width, texts[i]->height,
					GL_BGRA, GL_UNSIGNED_BYTE, hoja	 );
			}
			*/

	}
	~myIndexData (){}
	int currentmesh;
	void Begin (unsigned int submeshid, unsigned int indexcount)
	{
		//printf ("Begin: %d, %d\n", submeshid, indexcount);
		currentmesh=submeshid;
		currentsizes[submeshid]=indexcount;
		glBindBuffer (GL_ELEMENT_ARRAY_BUFFER, m_IndexBuffer[submeshid]);
	}
	void SetIndex (unsigned int i, unsigned int index) {
		//printf ("SetIndex: %d, %d\n", submeshid, index);
		indices[currentmesh][i]=index;
	}
	void End()
	{
		glBufferSubData(GL_ELEMENT_ARRAY_BUFFER, 0, currentsizes[currentmesh]*sizeof(int), indices[currentmesh]);
		//printf ("End\n");
	}
	void BorrowIndexData(const Geometry::IndexData* indexdata) {printf ("Error, BorrowIndexData called unexpectedly\n"); exit (-4);}

	void Render(float s) {

		glPolygonMode (	GL_FRONT_AND_BACK, GL_FILL);
		float sf=m->mMeshBounds.scaleFactor/s/2;
		glTranslatef(0,s/3,0);
		glScalef(sf, sf, sf);
		float d=m->mMeshBounds.maxY-m->mMeshBounds.minY;
		glEnable(GL_BLEND);
		glDisable ( GL_ALPHA_TEST ) ;
		glEnable(GL_LIGHTING);
		glEnable(GL_LIGHT0);

		//	glDisable(GL_DEPTH_TEST);
		glEnable(GL_TEXTURE_2D);


		float c[4]={1,1,1,1};
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, c);
		glColor4f (1,1,1,1);
		//glRotatef (rot,0 ,1,0);
		int current=0;
		int i;
		glBindTexture (GL_TEXTURE_2D, texturas[1]);
		for (i=0;i<m->mSubMeshCount;i++) {
			if (tree->GetLeavesSubMesh()==i) continue;
			glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, m_IndexBuffer[i]);
			glBindBuffer (GL_ARRAY_BUFFER, m_VertexBuffer[i]);

			glEnableClientState(GL_VERTEX_ARRAY);
			glVertexPointer(3, GL_FLOAT, sizeof(float)*size[i], (char*)0);   //The starting point of the VBO, for the vertices
			if (normalof[i]!=texcoorof[i]) {
				glEnableClientState(GL_NORMAL_ARRAY);
				glNormalPointer(GL_FLOAT, sizeof(float)*size[i], (char*)0+sizeof(float)*3);   //The starting point of normals,
			}
			if (texcoorof[i]!=size[i]) {
				glClientActiveTexture(GL_TEXTURE0);
				glEnableClientState(GL_TEXTURE_COORD_ARRAY);
				glTexCoordPointer(2, GL_FLOAT, sizeof(float)*size[i], (char*)0+sizeof(float)*6);   //The starting point of texcoords,
			}
			glDrawElements(GL_TRIANGLE_STRIP, currentsizes[i], GL_UNSIGNED_INT, (char*)0);
		}
		i=tree->GetLeavesSubMesh();
		glBindTexture (GL_TEXTURE_2D, texturas[0]);

		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glAlphaFunc ( GL_GREATER, 0.5 ) ;
		glEnable(GL_BLEND);
		//glEnable ( GL_ALPHA_TEST ) ;
		glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,1);

		/*rgh: uno a uno, como hace GeoTool
		glBegin(GL_TRIANGLES	);
		for (int j=0;j<currentsizes[i];j++) {
		int k=indices[i][j];
		glNormal3fv(vertices[i]+8*k+3);
		glTexCoord2fv(vertices[i]+8*k+6);
		glVertex3fv(vertices[i]+8*k);
		}
		glEnd();*/
		/*rgh: Ni siquiera la gente de Castelln pudo hacer funcionar esto (mirar cdigo GeoTool). Dejo de calentarme la cabeza. 
		Edit: Lo he echado a andar :o)
		*/
		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, m_IndexBuffer[i]);
		glBindBuffer (GL_ARRAY_BUFFER, m_VertexBuffer[i]);

		glEnableClientState(GL_VERTEX_ARRAY);
		glVertexPointer(3, GL_FLOAT, sizeof(float)*size[i], (char*)0);   //The starting point of the VBO, for the vertices 
		if (normalof[i]!=texcoorof[i]) {
			glEnableClientState(GL_NORMAL_ARRAY);
			glNormalPointer(GL_FLOAT, sizeof(float)*size[i], (char*)0+sizeof(float)*normalof[i]);   //The starting point of normals,
		}
		if (texcoorof[i]!=size[i]) {
			glClientActiveTexture(GL_TEXTURE0);
			glEnableClientState(GL_TEXTURE_COORD_ARRAY);
			glTexCoordPointer(2, GL_FLOAT, sizeof(float)*size[i], (char*)0+sizeof(float)*texcoorof[i]);   //The starting point of texcoords,
		}
		glDrawElements(GL_TRIANGLES, currentsizes[i], GL_UNSIGNED_INT, (char*)0);


	}

};
#endif

myIndexData *indexdata;
 
int GTinit (const char *c) 
{

	themesh=meshloader.load(c);
	//themesh=meshloader.load("./ML15a_10.mesh");
	//themesh=meshloader.load ("ML06a_01.mesh");
	indexdata=new myIndexData (themesh);
	if (!meshloader.GetLodStripsData() || !meshloader.GetTreeSimpSeq())
	{
		printf ("Tree mesh has no LOD\n");
		return (-1);	
	}	
	tree=new Geometry::LodTreeLibrary(meshloader.GetLodStripsData(), meshloader.GetTreeSimpSeq(),themesh, indexdata);
	return 1;
}

int GTnumVertices (int i)
{
	return themesh->mSubMesh[i].mVertexBuffer->mVertexCount;
}
/*
int GTnumIndices (int i)
{
	return indexdata->currentsizes[i];
}

int GTstride (int i)
{
	return indexdata->size[i];
}

int GTTexCoordPos (int i)
{
	return indexdata->texcoorof[i];
}

void GTvertices (int i, float *v)
{
	float *lv= indexdata->getVertices(i);
	for (int j=0;j<GTnumVertices(i)*GTstride(i);j++)
		v[j]=lv[j];
}

void GTindices (int i, int *x)
{
	unsigned int *lx=indexdata->getIndex(i);
	for (int j=0;j<GTnumIndices(i);j++)
		x[j]=(int)lx[j];
}

int GTmeshes (void)
{
	return themesh->mSubMeshCount;
}

int GTleaves (void)
{
	return tree->GetLeavesSubMesh();
}

float GTGetCurrentLod() 
{
	return tree->GetCurrentLodFactor();
}

void GTSetCurrentLod(float l)
{
	tree->GoToLod(l);
}
*/
int _tmain(int argc, _TCHAR* argv[])
{

	GTinit("media/ML06a_01.mesh");

	themesh=meshloader.load("media/ML06a_01.mesh");
	//themesh=meshloader.load("./ML15a_10.mesh");
	//themesh=meshloader.load ("ML06a_01.mesh");
	indexdata=new myIndexData (themesh);
	if (!meshloader.GetLodStripsData() || !meshloader.GetTreeSimpSeq())
	{
		printf ("Tree mesh has no LOD\n");
		return (-1);
	}	
	tree=new Geometry::LodTreeLibrary(meshloader.GetLodStripsData(), meshloader.GetTreeSimpSeq(),themesh, indexdata); 

	for ( float f = 0.0f; f < 1.0f; f += 0.001f )
	{
		tree->GoToLod(0.5f);
	}

	return 0;
}

